<template>
  <DefaultLayout
    :blog-post-lang-ref="$page.post.lang_ref"
    :blog-post-page-title="$page.post.title"
  >
    <a
      id="back-link"
      @click="$router.go(-1)"
    >
      {{ $t('back_to_previous_page') }}
    </a>
    <div class="article">
      <div class="article-header">
        <h1
          class="article-title"
          v-text="$page.post.title"
        />
        <div>
          <div id="other-locales">
            <span v-if="otherLocales.length">{{ $t('blog.also_available_in_other_languages') }}</span>
            <span v-else>{{ $t('blog.no_other_languages') }}</span>
            <div
              v-for="entry in otherLocales"
              :key="entry.code"
              class="other-locale-flag"
            >
              <a
                :v-if="entry.flag !== $i18n.locale"
                @click="switchToArticleInOtherLocale(entry.flag)"
              >
                <ClientOnly>
                  <country-flag
                    :country="entry.code"
                    size="normal"
                  />
                </ClientOnly>
              </a>
            </div>
          </div>
        </div>
        <div class="article-intro">
          <div class="article-meta">
            <div class="article-publication-date">
              <span class="article-meta-label">{{ $t('blog.fields.publication_date') }}</span>
              <span class="article-meta-value">
                {{ formatISODateTimeToLocale($page.post.publication_date, $i18n.locale) }}
              </span>
            </div>
            <div class="article-category">
              <span class="article-meta-label">{{ $t('blog.fields.category') }}</span>
              <span class="article-meta-value">{{ $t('blog.categories.' + $page.post.category) }}</span>
            </div>
            <div
              class="article-description"
              v-text="$page.post.description"
            />
          </div>
          <img
            class="article-banner-image fancy-border"
            :src="transformImageUrl($page.post.banner_image)"
            alt="Placeholder banner image for article"
          >
        </div>
      </div>

      <hr>

      <ArticleContent :content="$page.post.content" />
    </div>

    <div class="button-wrapper">
      <button
        id="load-comments-button"
        class="gradient-button blue-teal-blue-gradient"
        @click="shouldDisplayComments = true"
      >
        {{ $t('blog.load_comments') }} ▼
      </button>
    </div>
    <script type="application/javascript">
      // These variables have to be declared in the global scope (outside of Vue) to make Hyvor Talk work
      if (!window.hasOwnProperty('HYVOR_TALK_WEBSITE')) {
      var HYVOR_TALK_WEBSITE;
      }
      if (!window.hasOwnProperty('HYVOR_TALK_CONFIG')) {
      var HYVOR_TALK_CONFIG;
      }
    </script>
    <div id="comments-wrapper">
      <div
        v-if="shouldDisplayComments"
        id="comments-intro"
      >
        <hr>
        <h2>
          {{ $t('blog.comments') }}
        </h2>
        <span id="powered-by-hyvor-talk">
          {{ $t('blog.powered_by') }} <a
            href="https://talk.hyvor.com/"
            target="_blank"
          >Hyvor Talk</a>.
        </span>
      </div>
      <div id="hyvor-talk-view" />
    </div>
  </DefaultLayout>
</template>

<page-query>
  query ArticlePost($path: String!) {
    post: articlePost(path: $path) {
      id
      title
      publication_date(format: "D. MMMM YYYY")
      lang
      lang_ref
      category
      content
      description
      banner_image
      forestry_instant_preview_id
    }
  }
</page-query>

<static-query>
  query AllArticleList {
    allPosts: allArticlePost {
      edges {
        node {
          lang_ref
          lang
        }
      }
    }
  }
</static-query>

<script src="../scripts/templates/article-post.js"/>
<style lang="scss" src="../styles/templates/article-post.scss"/>
